
/** TP 5ETI - CPE Lyon - 2011/2012 */

#include <GL/glew.h>

#include "scene.hpp"
#include "glwidget.hpp"
#include "debug_mesh.hpp"

#include "../libmesh/opengl_drawer.hpp"
#include "../libperlin/perlin.hpp"



#include <QString>
#include <QFont>

#include <cmath>
#include <cassert>

using namespace cpe;



void scene::load_model()
{

    assert(p_widget!=NULL);
    assert(p_debug_mesh!=NULL);


    //*****************************************//
    // Generate mesh                           //
    //*****************************************//
    mesh_0.add_vertex(vec3(-1.0f,-0.5f, 0.0f));
    mesh_0.add_vertex(vec3( 0.0f,-0.5f, 0.2f));
    mesh_0.add_vertex(vec3( 1.0f,-0.5f, 0.0f));
    mesh_0.add_vertex(vec3(-1.0f, 0.5f, 0.0f));
    mesh_0.add_vertex(vec3( 0.0f, 0.5f, 0.2f));
    mesh_0.add_vertex(vec3( 1.0f, 0.5f, 0.0f));


    mesh_0.add_texture(vec2(0.0,0));
    mesh_0.add_texture(vec2(0.5,0));
    mesh_0.add_texture(vec2(1.0,0));
    mesh_0.add_texture(vec2(0.0,1));
    mesh_0.add_texture(vec2(0.5,1));
    mesh_0.add_texture(vec2(1.0,1));

    mesh_0.add_triangle(0,1,4);
    mesh_0.add_triangle(0,4,3);
    mesh_0.add_triangle(1,2,5);
    mesh_0.add_triangle(1,5,4);

    mesh_0.compute_normal();
    mesh_0.fill_color_xyz();

    const std::string texture_path="data/seamless_grass_texture.png";
    texture_id_0=0;
    texture_id_0=p_widget->bindTexture(QString(texture_path.c_str()),GL_TEXTURE_2D);
    if(texture_id_0==0)
        std::cout<<"Erreur chargement texture "<<texture_path<<std::endl;

    //*****************************************//
    // \Generate mesh                          //
    //*****************************************//

    //verification d'erreur OpenGL
    p_widget->check_opengl_error(__FUNCTION__);
}

void scene::draw_scene()
{
    glEnable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);

    glColor3d(1,1,1);


    //draw mesh
    glBindTexture(GL_TEXTURE_2D,texture_id_0);
    cpe::opengl_drawer::draw(mesh_0);

    //draw debug information if asked in the GUI
    p_debug_mesh->draw_debug(mesh_0);



    //verification d'erreur OpenGL
    p_widget->check_opengl_error(__FUNCTION__);
}





scene::scene()
{

    p_widget=NULL;
    p_debug_mesh=NULL;

    texture_id_0=0;
}


void scene::set_glwidget(glwidget *p_widget_)
{
    p_widget=p_widget_;
}
void scene::set_debug_mesh(cpe::debug_mesh *p_debug_mesh_)
{
    p_debug_mesh=p_debug_mesh_;
}
